<?php
/**
 * Mirasvit
 *
 * This source file is subject to the Mirasvit Software License, which is available at https://mirasvit.com/license/.
 * Do not edit or add to this file if you wish to upgrade the to newer versions in the future.
 * If you wish to customize this module for your needs.
 * Please refer to http://www.magentocommerce.com for more information.
 *
 * @category  Mirasvit
 * @package   mirasvit/module-email
 * @version   2.4.0
 * @copyright Copyright (C) 2022 Mirasvit (https://mirasvit.com/)
 */


declare(strict_types=1);


namespace Mirasvit\EmailDesigner\Service\TemplateEngine;



class Translator
{
    /**
     * Translate email template text.
     * Text translated string by string.
     */
    public function render(string $template, array $variables = []): string
    {
        $translatedStrings = [];
        $strings = explode("\n", $template);

        foreach ($strings as $idx => $string) {
            $searchString = trim($string);
            $trans = (string)__($searchString)->render();

            $translatedStrings[] = str_replace($searchString, $trans, $string);
        }

        return implode("\n", $translatedStrings);
    }
}
